      DOUBLE PRECISION FUNCTION SF36D(X,A,B,IERR)
      INTEGER IERR,IB,IERR1,INT
      DOUBLE PRECISION X,A,B,PS,PX,Y,P1,DA,XINT,CNT,
     1WH,XB,DB,C,TOT,RAB,D4,TEMP,EPS2,R1,R2,DEXP,DFLOAT,
     1DLOG,SYS055,SYS059,SYS077,SYS089,PQ
      DATA  SYS089/1.D-15/,SYS059/1.7D308/,SYS055/
     12.2251D-308/,SYS077/-7.083964D+2/
      Y=X
      IF((X.LE.1.0D0).AND.(X.GE.0.0D0)) GO TO 1
      IERR=65
      GO TO 13
    1 IF((A.GT.0.0D0).AND.(B.GT.0.0D0)) GO TO 2
      IERR=66
      GO TO 13
    2 IERR=0
      EPS2=SYS089
      IF(X.GT.0.5D0) GO TO 3
      INT=0
      GO TO 4
    3 INT=1
      TEMP=A
      A=B
      B=TEMP
      Y=1.D0-Y
    4 IF(X.NE.0.AND.X.NE.1.D0) GO TO 5
      SF36D=0.D0
      GO TO 12
    5 IB=B
      TEMP=IB
      PS=B-DFLOAT(IB)
      IF(B.EQ.TEMP) PS=1.D0
      DA=A
      DB=B
      PX=DA*DLOG(Y)
      CALL SF23P(DA+DB,0.D0,PQ,RAB,EPS2,0,IERR1)
      EPS2=SYS089
      CALL SF23P(DA,0.D0,P1,RAB,EPS2,0,IERR1)
      EPS2=SYS089
      CALL SF23P(DB,0.D0,C,RAB,EPS2,0,IERR1)
      D4=DLOG(DA)
      EPS2=SYS089
      CALL SF23P(PS+DA,0.D0,R1,RAB,EPS2,0,IERR1)
      EPS2=SYS089
      CALL SF23P(PS,0.D0,R2,RAB,EPS2,0,IERR1)
      XB=PX+R1-R2-D4-P1
      IB=XB/SYS077
      XINT=0.D0
      IF(IB.NE.0) GO TO 7
      XINT=DEXP(XB)
      CNT=XINT*DA
      WH=0.D0
    6 WH=WH+1.D0
      CNT=CNT*(WH-PS)*Y/WH
      XB=CNT/(DA+WH)
      XINT=XINT+XB
      IF(XB/SYS089.GT.XINT) GO TO 6
    7 TOT=0.D0
      IF(DB.LE.1.D0) GO TO 11
      XB=PX+DB*DLOG(1.D0-Y)+PQ-P1-DLOG(DB)-C
      IB=XB/SYS077
      IF(IB.LT.0) IB=0
      C=1.D0/(1.D0-Y)
      CNT=DEXP(XB-DFLOAT(IB)*SYS077)
      PS=DB
      WH=DB
    8 WH=WH-1.D0
      IF(WH.LE.0.0D0) GO TO 11
      PX=(PS*C)/(DA+WH)
      IF(PX.GT.1.D0) GO TO 9
      IF(CNT/SYS089.LE.TOT.OR.CNT.LE.SYS055/PX) GO TO 11
    9 CNT=CNT*PX
      IF(CNT.LE.1.D0) GO TO 10
      IB=IB-1
      CNT=CNT*SYS055
   10 PS=WH
      IF(IB.EQ.0) TOT=TOT+CNT
      GO TO 8
   11 SF36D=TOT+XINT
   12 IF(INT.EQ.0) GO TO 14
      SF36D=1.D0-SF36D
      TEMP=A
      A=B
      B=TEMP
      GO TO 14
   13 CONTINUE
      CALL UTSF13(IERR,36)
      SF36D=SYS059
   14 RETURN
      END
